/*
; ƬͨCH372CH375ӵPCUSBͨѶĿܳ
; includeֱӰӦϵͳ,ӵĿ
;
; Website:  http://winchiphead.com
; Email:    tech@winchiphead.com
; V1.0 @2004.09, V1.1 @2004.12
;****************************************************************************
*/

/* C, ôƬ,MCS51Լں˵ĵƬ */
/* ƬͻӲԴͬʱ, óӦøҪоֲ޸ */

#include "CH375INC.H"

#ifdef __CX51__
#ifndef __C51__
#define __C51__		1
#endif
#endif

typedef unsigned char                 UINT8;
typedef unsigned short                UINT16;
typedef unsigned long                 UINT32;
#ifdef __C51__
typedef unsigned char  idata         *PUINT8;
typedef unsigned char volatile xdata  IOPORT;
#pragma NOAREGS
#include <reg52.h>
#else
typedef unsigned char                *PUINT8;
typedef unsigned char volatile        IOPORT;
#endif

#define DELAY_START_VALUE		1	  /* ݵƬʱѡʱֵ */

/*#define MY_USB_VENDOR_ID		0x1A86*/	/* ԼUSB豸ĳID */
/*#define MY_USB_PRODUCT_ID		0x5537*/	/* ԼUSB豸ĲƷID */
/*#define ENABLE_USB_SUSPEND		1*/		/* USBߵĹ״̬,ڽ͹ģʽ */

IOPORT		CH375_CMD_PORT _at_ 0xBDF1;		/* CH375˿ڵI/Oַ,ʵӲ·޸ */
IOPORT		CH375_DAT_PORT _at_ 0xBCF0;		/* CH375ݶ˿ڵI/Oַ,ʵӲ·޸ */

/* ʱ1΢,ȷ,ҪӲʵ */
void	Delay1us( )
{
#if DELAY_START_VALUE != 0
	UINT8 i;
	for ( i=DELAY_START_VALUE; i!=0; i-- );
#endif
}

/* ʱ2΢,ȷ,ҪӲʵ */
void	Delay2us( )
{
	UINT8 i;
	for ( i=DELAY_START_VALUE*2+1; i!=0; i-- );
}

/* CH372/CH375йصĻI/O */

void CH375_WR_CMD_PORT( UINT8 cmd ) {  /* CH375˿д,ڲС4uS,ƬϿʱ */
	Delay2us();
	CH375_CMD_PORT=cmd;
	Delay2us();
}

void CH375_WR_DAT_PORT( UINT8 dat ) {  /* CH375ݶ˿д,ڲС1.5uS,ƬϿʱ */
	CH375_DAT_PORT=dat;
	Delay1us();  /* MCS51Ƭ,,ʵʱ */
}

UINT8 CH375_RD_DAT_PORT( void ) {  /* CH375ݶ˿ڶ,ڲС1.5uS,ƬϿʱ */
	Delay1us();  /* MCS51Ƭ,,ʵʱ */
	return( CH375_DAT_PORT );
}

/* CH375ʼӳ */
void	CH375_Init( void ) {
	UINT8 i;

#ifdef MY_USB_VENDOR_ID
#ifdef MY_USB_PRODUCT_ID
/* ⲿԶUSB豸VIDPID,ѡ,ִиʹĬϵVIDPID,
   ʹԶID,ôINFװļе"USB\VID_4348&PID_5537"Ҫ޸ */
	CH375_WR_CMD_PORT( CMD_SET_USB_ID );  /* ⲿԶUSB豸VIDPID,ѡ */
	CH375_WR_DAT_PORT( (UINT8)MY_USB_VENDOR_ID );  /* д볧IDĵֽ */
	CH375_WR_DAT_PORT( (UINT8)(MY_USB_VENDOR_ID>>8) );  /* д볧IDĸֽ */
	CH375_WR_DAT_PORT( (UINT8)MY_USB_PRODUCT_ID );  /* дƷIDĵֽ */
	CH375_WR_DAT_PORT( (UINT8)(MY_USB_PRODUCT_ID>>8) );  /* дƷIDĸֽ */
#endif
#endif

/* USBģʽ, Ҫ */
	CH375_WR_CMD_PORT( CMD_SET_USB_MODE );
	CH375_WR_DAT_PORT( 2 );  /* Ϊʹù̼USB豸ʽ */
	for ( i=100; i!=0; i-- ) if ( CH375_RD_DAT_PORT( ) == CMD_RET_SUCCESS ) break;  /* ȴɹ,ͨҪȴ10uS-20uS */
/*	if ( i == 0 ) { CH372/CH375оƬڲӴӲ }; */

#ifdef ENABLE_USB_SUSPEND
/* üUSB߹״̬,USB߹ʱʹCH375Ҳ͹״̬ */
	CH375_WR_CMD_PORT( CMD_CHK_SUSPEND );  /* üUSB߹״̬ķʽ */
	CH375_WR_DAT_PORT( 0x10 );
	CH375_WR_DAT_PORT( 0x04 );  /* 50mSΪUSB */
#endif

/* USBж,CH375INT#ſӵƬж,жΪ͵ƽЧ½Ч,
   ʹж,ôҲòѯʽ,ɵƬѯCH375INT#Ϊ͵ƽ˵CH375ж */
#ifdef __C51__
	IT0 = 0;  /* ⲿźΪ͵ƽ */
	IE0 = 0;  /* жϱ־ */
	EX0 = 1;  /* CH375ж,ٶCH375INT#ӵƬINT0 */
#endif
}

UINT8	UsbLength;							/* USBݻݵĳ */
UINT8	UsbBuffer[ CH375_MAX_DATA_LEN ];	/* USBݻ */

/* CH375жϷ,ٶCH375INT#ӵƬINT0,ʹüĴ1 */
void	mCH375Interrupt( void ) interrupt 0 using 1 {
	UINT8			IntStatus;
	UINT8			cnt;
	PUINT8			buf;
	CH375_WR_CMD_PORT( CMD_GET_STATUS );  /* ȡж״̬ȡж */
	IntStatus = CH375_RD_DAT_PORT( );  /* ȡж״̬ */
/*	IE0 = 0;  жϱ־,뵥ƬӲй,ӦINT0ж */
	switch( IntStatus ) {  /* ж״̬ */
		case USB_INT_EP2_OUT:  /* ˵´ɹ,յ */
			CH375_WR_CMD_PORT( CMD_RD_USB_DATA );  /* ӵǰUSBжϵĶ˵㻺ȡݿ,ͷŻ */
/* ʹCMD_RD_USB_DATA0,ôȡݿ󲻻ԶͷŻ,ҪCMD_UNLOCK_USBͷ */
			UsbLength = cnt = CH375_RD_DAT_PORT( );  /* ȶȡݳ */
			if ( cnt ) {  /* յݷŵ */
				buf = UsbBuffer;  /* ָ򻺳 */
				do {
					*buf = CH375_RD_DAT_PORT( );  /*  */
					buf ++;
				} while ( -- cnt );
			}
			else break;  /* Ϊ0,û,ĳЩӦҲԽ0Ϊһ */
/* յݲ,˴ȥ,ʾش */
			CH375_WR_CMD_PORT( CMD_WR_USB_DATA7 );  /* USB˵2ķͻдݿ */
			cnt = UsbLength;
			CH375_WR_DAT_PORT( cnt );  /* дݳ */
			if ( cnt ) {  /* еݷ */
				buf = UsbBuffer;  /* ָ򻺳 */
				do {
					CH375_WR_DAT_PORT( *buf );  /* дݵCH375 */
					buf ++;
				} while ( -- cnt );
			}
			break;
		case USB_INT_EP2_IN:  /* ˵ϴɹ,ݷͳɹ */
/* Ҫŷ,ڴͨCMD_WR_USB_DATA7д,οǰĻش */
			CH375_WR_CMD_PORT( CMD_UNLOCK_USB );  /* ͷŵǰUSB,յϴɹжϺ,USB,Աշ */
			break;
		case USB_INT_EP1_IN:  /* ж϶˵ϴɹ,жݷͳɹ */
/* ж϶˵ڵƬʱ֪ͨ,δõ */
			CH375_WR_CMD_PORT( CMD_UNLOCK_USB );  /* ͷŵǰUSB */
			break;
		case USB_INT_EP1_OUT:  /* ˵´ɹ,յ */
/* ˵ڼƬ˷Ͱ,δõ,ݵĽտԲο˵ */
			CH375_WR_CMD_PORT( CMD_UNLOCK_USB );  /* ͷŵǰUSB */
			break;
#ifdef ENABLE_USB_SUSPEND
/* Ĭ²Щж״̬,ֻеִӦŻЩ״̬,Ҫ */
		case USB_INT_USB_SUSPEND:  /* USB߹¼,ֻеִйCMD_CHK_SUSPENDſָܳж״̬ */
			CH375_WR_CMD_PORT( CMD_UNLOCK_USB );  /* ͷŵǰUSB */
			CH375_WR_CMD_PORT( CMD_ENTER_SLEEP );  /* ǿѡ,͹˯߹״̬ */
			break;
		case USB_INT_WAKE_UP:  /* ˯б¼,ֻеִйCMD_ENTER_SLEEPſָܳж״̬ */
			CH375_WR_CMD_PORT( CMD_UNLOCK_USB );  /* ͷŵǰUSB */
			break;
#endif
		default:
/* ù̼USBʽ²Ӧóж״̬,USB߹,ôҪUSB߹˯߻¼ */
			CH375_WR_CMD_PORT( CMD_UNLOCK_USB );  /* ͷŵǰUSB */
			break;
	}
}

/*
main( void ) {
	CH375_Init( );
	EA = 1;
	while ( 1 );
}
*/
